/*

	SETEGAD.C -- Set EGAD Screen Print parameters

	EGAD

	Copyright (c) 1989, 1990, 1991 LS Software

	8139 E. Mawson
	Mesa, AZ 85207
	(602) 380-9175

	All Rights Reserved. No part of this program may be reproduced
	in whole or in part without express permission of LS Software.

*/

#include <dos.h>
#include <conio.h> 
#include <stdio.h> 
#include <stdlib.h> 
#include <fcntl.h> 
#include <io.h> 
#include <memory.h> 
#include <string.h> 
#include "keys.h"
#include "screen.h"
#include "setegad.h"
#include "version.h"

extern int system_type();		/* 0 if PC, 1 if Z-100 */
extern PRINTER_DEF *characteristics[];

#define MAX_X		800
#define MAX_Y		600

extern int get_int_key;

extern int which_printer;	/* 0..NPRINTERS-1 */
extern int in_mem;		/* -1 if no driver in mem; else which_printer */
extern int setting_disk;	/* 0 if not */
extern int setting_mem;		/* 0 if not */
extern int mem_version;		/* VER_* */
extern int disk_version;	/* VER_* */

extern int prog_file;
extern long par_loc, lcheck;
extern unsigned int ucheck;
extern char prog_name[];
extern char out_port[];

extern char *Press_Ret;

void show_enlargement(PAR_T *ptr);

char Disabled[]="Disabled";
char Enabled[]= "Enabled ";
char *Yea_Nay_Menu[]={Disabled,Enabled};
static char *mem_not_avail = "Only available if setting memory";

#if 0
 char VertPage_Title[]="Vertical Printout Position:";
 char VertPage_None[]="None (No Page Eject)";
 char VertPage_Eject[]="Top (Eject Page)";
 char VertPage_Center[]="Center (& Eject Page)";
 char VertPage_Bottom[]="Bottom of Page";
 char *VertPage_Menu[]={VertPage_None,VertPage_Eject,
			VertPage_Center,VertPage_Bottom};
 #define VertPage_N 4
 char VertPage_Inst[]=
"'None' ignores page breaks;\n\
other options force page eject\n\
after each printout.\n";
#else
 char VertPage_Title[]="Page Eject After Print";
 #define VertPage_Menu Yea_Nay_Menu
 #define VertPage_N 2
#endif

#ifdef OEM

void inch_print (int value)
   {
      printf("%2d.%1d\"", value/10,value%10);
   }

void size_print (int x, int y)
   {
      if (x==0) {
	 printf("   -n/a-   ");
      } else {
	 inch_print(x);
	 printf("x");
	 inch_print(y);
      }
   }

void modify_bar(char *inbar, char *outstr, char change_to)
   {
      char *p;

      strcpy(outstr,inbar);
      while ((p = strchr(outstr,'X')) != NULL) {
	 *p = change_to;
      }
   }

extern char far *prtsc_vec;

/* Printer graphics mode */
typedef struct {
   int command_ptr;	/* pointer to command to send for this mode */
   int length_ptr;	/* pointer to place to put length data */
   int xdpi, ydpi;	/* X and Y resolution (dots/inch) */
} PRN_MODE;

/* Screen to printer graphics map */
typedef struct {
   int xdots, ydots;	/* Truncation limits, in screen pixels */
   int pmode;		/* Printer graphics mode to use */
   int rept;		/* Repeat factor */
   int rotate;		/* Whether to rotate the image */
   int pattern;		/* Offset of bit pattern to use */
   int xin, yin;	/* Print size, in 1/10" */
} PRN_GMAP;

/* Pattern header */
typedef struct {
   unsigned char pat_width;	/* 6, 7, or 8 bits usable */
   unsigned char pat_size;	/* Size of pattern */
} PRN_PATTERN;

int sel_advanced(PAR_T *ptr)
   {
      PRN_PATTERN far *p_pattern;
      PRN_MODE far *p_mode;
      PRN_GMAP far *p_gmapbase;
      PRN_GMAP far *p_gmap;
      int i, vmode, vmode_print;
      char barcopy[82];

      int horiz_pixels;	/* TRUE if printer data is horizontal bytes */
      unsigned int x_print_in, y_print_in; /* Size of normal printout, 1/10" */

      static char *yesno[]={"No ","Yes"};
      static char *videomode[]={
	 "",
	 "CGA 320x200","CGA 640x200",
	 "EGA 640x350","VGA 640x480",
	 "MGA 720x348","Reduction"
      };
      static int video_x[]={320,640,640,640,720,0};
      static int video_y[]={200,200,350,480,384,0};
      static char *bar="XXXXX\n";

      /* If not setting, we don't have these variables! */
      if (!setting_mem) {
	 show_error(mem_not_avail,10,43,0);
	 return;
      }
      cls();
      /* Be sure it matches */
      if (ptr->hdr_nvars < 12 || ptr->hdr_version < 241) {
	 return;
      }
#if 0
      printf("Crop Box:\n");
      printf("   Adjust color:      %d\n",  ptr->crop_colora);
      printf("   'Dead' color:      %d\n",  ptr->crop_colorb);
      printf("   Default Increment: %d\n\n",ptr->crop_incr);
      printf("Header:   # Vars = %d  Version = %d  PSP at %04xx\n\n",
	 ptr->hdr_nvars, ptr->hdr_version, ptr->tsr_psp_seg);
      printf("   # Maps = %d\n",ptr->hdr_nmap);
      printf("   Map0   = %04xx\n",ptr->hdr_map0);
#endif

      p_gmapbase = (void far *)prtsc_vec;
      FP_OFF(p_gmapbase) = ptr->hdr_map0;
      p_mode = (void far *)prtsc_vec;
      FP_OFF(p_mode) = ptr->hdr_mode0;

      printf("Printer: %s", characteristics[which_printer]->Printer_Name);
      if (ptr->hdr_ncolors > 0) {
	 vmode = ptr->hdr_dith_lev;
	 i = ptr->hdr_ncolors;
	 if (vmode == 2 && i == 4) {
	    i--;	/* If just ON/OFF and 4 colors (incl. black) */
	 }
	 for ( ; i>1; i--) {
	    vmode *= ptr->hdr_dith_lev;
	 }
	 printf("\t\t(%d %ss)", vmode, ptr->hdr_iscolor?"Color":"Gray Tone");
      }

      printf("\n\n               THESE PARAMETERS ARE PRE-SET:           RESULTING SIZES:\n");
      modify_bar(bar, barcopy, '');
      printf(barcopy);
      printf("   Video         RepeatPixelsPrinter   Printable Max. Scrn  Normal\n");
      printf("   Mode    RotateFactor /ByteRes (dpi) Page Area Pixels   Print Size\n");
      modify_bar(bar, barcopy, '');
      printf(barcopy);
      /*      sssssssssss  sss    _     _   ___x___ __._"x__._"____x______._"x__._" */

      horiz_pixels = ptr->hdr_pixorient;

      for (vmode=0; vmode < ptr->hdr_secmap; vmode++) {
	 vmode_print = vmode + 1;
	 /* For each rotation available for this video mode: */
	 for (i = vmode; i < ptr->hdr_nmap; i += ptr->hdr_secmap) {
	    p_gmap = &p_gmapbase[i];
	    p_pattern = (void far *)prtsc_vec;
	    FP_OFF(p_pattern) = p_gmap->pattern - 1;

	    if (p_gmap->rotate) {
	       x_print_in = video_y[vmode];
	       y_print_in = video_x[vmode];
	    } else {
	       x_print_in = video_x[vmode];
	       y_print_in = video_y[vmode];
	    }
	    if (p_pattern->pat_size != 0) {
	       if (horiz_pixels) {
		  x_print_in = (x_print_in * 10 * p_pattern->pat_width) / p_pattern->pat_size;
		  y_print_in = y_print_in * 10 * p_gmap->rept;
	       } else {
		  x_print_in = x_print_in * 10 * p_gmap->rept;
		  y_print_in = (y_print_in * 10 * p_pattern->pat_width) / p_pattern->pat_size;
	       }
	       x_print_in /= p_mode[p_gmap->pmode].xdpi;
	       y_print_in /= p_mode[p_gmap->pmode].ydpi;
	    }

	    printf("%11s%c %s %4d  %4d  %4dx%3d ",
	       videomode[vmode_print],vmode_print?'*':' ',
	       yesno[p_gmap->rotate],
	       p_gmap->rept,p_pattern->pat_size,
	       p_mode[p_gmap->pmode].xdpi,p_mode[p_gmap->pmode].ydpi);
	    size_print(p_gmap->xin,p_gmap->yin);
	    printf("%4dx%4d",p_gmap->xdots,p_gmap->ydots);
	    size_print(x_print_in, y_print_in);

	    printf("\n");

	    vmode_print = 0;
	 }
      }
      modify_bar(bar, barcopy, '');
      printf(barcopy);
      printf("  * indicates settings chosen with 'Auto Rotation'\n\n");
      printf(Press_Ret);
      while (gtkey() != NL) ;
   }
#endif

void show_ff(ptr)
PAR_T *ptr;
{  int msg;

   setcur(4,1);
   wstr("Page Eject: ");
   msg = ptr -> setff;
   if ((msg < 0) || (msg >= VertPage_N))
      msg = 0;
   wstr(VertPage_Menu[msg]);
}

void sel_ff(ptr)
PAR_T *ptr; /* Parameter array */
{   int x;

#ifdef VertPage_Inst
	instruction(VertPage_Inst,18,42);
#endif
	x = menu(VertPage_Title,VertPage_Menu,VertPage_N,10,42);
	if (x >= 0) {
	   ptr -> setff = x;
	   show_ff(ptr);
	}
#ifdef VertPage_Inst
	erase_instruction();
#endif
}

char HorizPage_Title[]="Print Alignment";
char *HorizPage_Menu[]={"~Left    ","~Right   ","~Centered"};
#define HorizPage_N 3
char HorizPage_Inst[]=
"Selects whether the printout\n\
will be placed at the left or\n\
right margin, or centered.\n";

void show_align(PAR_T *ptr)
{ int msg;
   setcur(3,24);
   wstr("Align: ");
   msg = ptr->centering;
#if 1
   highlight(HorizPage_Menu[msg>0?msg-1:0],-1,-1,-1);
#else
   wstr(HorizPage_Menu[msg>0?msg-1:0]);
#endif
}

void sel_align(ptr)
PAR_T *ptr; /* Parameter array */
{   int x;

	instruction(HorizPage_Inst,18,42);
	x = menu(HorizPage_Title,HorizPage_Menu,HorizPage_N,10,42);
	if (x >= 0) {
	   ptr -> centering = x+1;
	   show_align(ptr);
	}
	erase_instruction();
}

/* Get or Set the BIOS Print Screen Status
   if argument is:
	-1	returns current status (0=inhibited, 1=enabled)
	0	inhibits PrtSc key
	1	enables PrtSc key
*/

int bios_prtsc(int new)
{
	if (new < 0)	
	  return(!*((char far *)PRTSC_STAT));
	else
	  *((char far *)PRTSC_STAT) = new?0:1;
	return(0);
}

void show_prtsc()
{
	setcur(5,24);
	wstr("PrtSc: ");
	if (bios_prtsc(-1))
	  wstr(Enabled);
	else
	  wstr(Disabled);
}

char prtsc_msg[]=
"This IMMEDIATELY enables\n\
or disables the Print-Screen\n\
key, whether or not you Save\n\
or Discard other changes.\n";

void sel_prtsc()
{   int x;

	if (!setting_mem)
	  show_error(mem_not_avail,10,43,0);
	else
	  { instruction(prtsc_msg,18,42);
	    x = menu("Print-Screen Key",Yea_Nay_Menu,2,10,42);
	    if (x >= 0)
		bios_prtsc(x);
	    erase_instruction();
	  }
}

void show_tsr_box_0(ptr)
PAR_T *ptr;
{
	setcur(2,3);
	wstr("Region:");
	setcur(2,15);
	printf("(%3d,%3d)-(%3d,%3d)",
	ptr->tsr_x1-1,ptr->tsr_y1-1,ptr->tsr_x2-1,ptr->tsr_y2-1);
}

void show_tsr_box(ptr)
PAR_T *ptr;
{
	setcur(2,3);
	wstr("Region:");
	if (ptr->tsr_x2 == 1)
	  wstr  ("     (Whole Screen)    ");
	else
	  show_tsr_box_0(ptr);
}

static char *crop_box_options[]={"~Whole Screen","~Specific Region"};
char box_msg[]="\
Enter coordinates. Press ENTER\n\
after each one.\n\
(0,0) is Upper Left corner.\n";

void sel_box(ptr)
PAR_T *ptr;
{	int x;

	x = menu("Default Crop Box Region",crop_box_options,2,10,42);
	switch (x)
	  { case 0:	/* Whole screen */
		ptr->tsr_x2 = ptr->tsr_y2 = 1;
		break;
	    case 1:
		instruction(box_msg,10,42);

		show_tsr_box_0(ptr);
		setcur(2,16);
		ptr->tsr_x1 = get_int(ptr->tsr_x1-1,0)+1;
		show_tsr_box_0(ptr);

		setcur(2,20);
		ptr->tsr_y1 = get_int(ptr->tsr_y1-1,0)+1;
		show_tsr_box_0(ptr);

		setcur(2,26);
		ptr->tsr_x2 = get_int(ptr->tsr_x2-1,0)+1;
		show_tsr_box_0(ptr);

		setcur(2,30);
		ptr->tsr_y2 = get_int(ptr->tsr_y2-1,0)+1;

		if (ptr->tsr_x2 < ptr->tsr_x1)
		  ptr->tsr_x2 = ptr->tsr_x1;
		if (ptr->tsr_y2 < ptr->tsr_y1)
		  ptr->tsr_y2 = ptr->tsr_y1;
		if (ptr->tsr_x2 > MAX_X)
		  ptr->tsr_x2 = MAX_X;
		if (ptr->tsr_y2 > MAX_Y)
		  ptr->tsr_y2 = MAX_Y;

		show_tsr_box_0(ptr);
		erase_instruction();
	  }
}

void show_crop(ptr)
PAR_T *ptr;
{
	setcur(1,1);
	wstr("Crop Box:   ");
	if (ptr->tsr_box)
	  wstr(Enabled);
	else
	  wstr(Disabled);
}

static char *Crop_Menu[] = {
	"~Disable Crop Box",
	"~Enable Crop Box",
	"~Region...",
	"E~xit to Change Menu"
	};

void sel_crop(ptr)
PAR_T *ptr; /* Parameter array */
{
int sel;
    /* Find out what is to be changed. */
    do {
	sel=menu("Crop Box Menu",Crop_Menu,4,10,42);
	switch(sel) {
	    case 0:
	    case 1:
	        ptr -> tsr_box = sel;
		show_crop(ptr);
		show_enlargement(ptr);
		break;
	    case 2:
		sel_box(ptr);
		break;
	    default:
		sel = -1;
	}
    } while (sel >= 0);
}

void show_enlargement(PAR_T *ptr)
{
	setcur(4,24);
	wstr("Enlarge: " );
	if (ptr -> tsr_box) {		/* If crop box enabled, not applic. */
	   printf("N/A");
	} else {
	   if (ptr->tsr_enlarge == 5) {
	      printf("1.5x");
	   } else {
	      printf ("%3dx",ptr->tsr_enlarge);
	   }
	}
	
}

char *enlargements[]={"~0 (Reduction)","~1 (Normal size)",
"~2x Enlargement","~3x Enlargement","~4x Enlargement",
"1.~5x Enlargement"};
static char enl_msg[]="\
Setting the Enlargement will\n\
disable the User-Adjustable\n\
Crop Box.\n";

void sel_enlargement(ptr)
PAR_T *ptr;
   {	
      int x;

      if (ptr ->tsr_box) {
	 instruction(enl_msg,21,42);
      }
      x = menu("Enlargement/Reduction",enlargements,6,10,42);
      if (x >= 0) {
	 ptr -> tsr_box = 0;		/* Disable crop box */
	 ptr -> tsr_enlarge = x;
      }
      show_crop(ptr);
      show_enlargement(ptr);
      erase_instruction();
   }

static char *Orient_Menu[] = {
	"~Auto     ",
	"~Portrait ",
	"~Landscape"
	};

static char *Orient_Inst =
"Determines whether graphics print-\n\
outs will be Portrait or Landscape.\n\
The default is 'Auto' which allows\n\
EGAD to choose which orientation\n\
best matches your printer.\n";

void show_orient(ptr)
PAR_T *ptr;
{
      setcur(3,1);
      wstr("Orientation:");
#if 1
      highlight(Orient_Menu[ptr->orientation],-1,-1,-1);
#else
      wstr(Orient_Menu[ptr->orientation]);
#endif
}

void sel_orient(ptr)
PAR_T *ptr;
   {
      int x;

      instruction(Orient_Inst,18,42);
      x = menu("Printout Orientation",Orient_Menu,3,10,42);
      if (x >= 0) {
	 ptr -> orientation = x;
	 show_orient(ptr);
      }
      erase_instruction();
   }

/* Return number of serial ports */

int n_comports()
{ int i = 0;

	while (i < MAXPORT && *((int far *)SERPORTS+i))
	  i++;
	return(i);
}

/* Return the number of printer ports */

int n_prnports()
{ int i = 0;

	while (i < MAXPORT && *((int far *)PARPORTS+i))
	  i++;
	return(i);
}

char *Port_Menu[]={"  LPT1","  LPT2","  LPT3",
	"  COM1","  COM2","  COM3","  COM4"};

void show_port(ptr)
PAR_T *ptr;
{   int x;
    char pt[6];
    setcur(5,1);
    wstr("Print Port: ");
    x = ptr -> unit;
    if (x == 0)			/* Z-100 PRN output */
      wstr("PRN");
    else      
      {	if(x > 0)
	  strcpy(pt,"LPTx");
	else
	  strcpy(pt,"COMx");
	pt[3]=(char)abs(x)+'0';
	wstr(pt);
      }
}

char port_msg[]="\
Select port and press ENTER, or\n\
press ESC to leave unchanged.\n\
\x0FB indicates installed ports\n";

void sel_port(ptr)
PAR_T *ptr; /* Parameter array */
{
int x;

    if (system_type())		/* On Z-100, not configurable */
      { show_error("Use CONFIGUR to change",10,43,0);
        return;
      }

    /* Check off installed equipment */

    for (x=0; x<n_prnports(); x++)
      Port_Menu[x][0]=251;
    for (x=0; x<n_comports(); x++)
      Port_Menu[x+3][0]=251;

    instruction(port_msg,21,42);
    x = menu("Printer Port Selection",Port_Menu,7,9,42);
    erase_instruction();

    if (x < 0)
	return;		/* No change */

    /* 1 = LPT1, 2 = LPT2, 3=LPT3, -1=COM..-4=COM4 */
    if(x>2)
	ptr->unit = 2-x;	/* Serial port */
    else
	ptr->unit = x+1;	/* Parallel port */
}

int show_status(ptr,str)
PAR_T *ptr; /* Parameter array */
char *str;  /* Memory/Program indicator */
{ int i=0;
    cls();
    box(0,0,24,40,1);
    setcur(0,10);
    wstr("\1 Current Parameters \2");

    show_port(ptr);
    if (setting_mem) {
    	show_prtsc();
    }
    show_ff(ptr);
    show_align(ptr);
    show_crop(ptr);
    show_enlargement(ptr);
    show_tsr_box(ptr);
    show_colors(ptr);
    show_orient(ptr);

    box(0,42,8,75,2);
    i=1;
    setcur(i++,43);
    wstr("Printer:");
    setcur(i++,45);
    wstr(characteristics[which_printer]->Printer_Name);

    setcur(i++,43);
    wstr("Parameters were taken from:");
    setcur(i++,45);
    wstr(str);

    setcur(i++,43);
    wstr("...and will be saved to:");
    setcur(i++,45);
    if (setting_mem) {
        wstr("Memory");
	if (setting_disk) wstr(", and ");
      }
    if (setting_disk) {
        wstr("Disk File ");
	if (strlen(prog_name)>=20)
	  setcur(i++,47);		/* Put on the next line */
	wstr(prog_name);
      }

    return(0);
}

static char *Page_Menu[] = {
	"~Orientation...",
	"~Alignment...",
	"~Page Eject...",
	"~Enlargement...",
#ifdef OEM
	"Print ~Sizing...",
#endif
	"E~xit to Change Menu"
	};

int sel_page(ptr,str)
PAR_T *ptr; /* Parameter array */
char *str;
{
int sel;
    /* Find out what is to be changed. */
    do {
#ifdef OEM
	sel=menu("Printout Attributes",Page_Menu,6,10,42);
#else
	sel=menu("Printout Attributes",Page_Menu,5,10,42);
#endif
	switch(sel) {
	    case 0:
		sel_orient(ptr);
		break;
	    case 1:
		sel_align(ptr);
		break;
	    case 2:
		sel_ff(ptr);
		break;
	    case 3:
		sel_enlargement(ptr);
		break;
#ifdef OEM
	    case 4:
	       sel_advanced(ptr);
	       show_status(ptr,str);
	       break;
#endif
	    default:
		sel = -1;
	}
    } while (sel >= 0);
}

static char *Select_Menu[]={
	"~Colors...",
	"Crop ~Box...",
	"Printout ~Attributes...",
	"Printer ~Port",
	"Print-Screen ~Key",
	"E~xit to Save Menu"};

void sel_operation(ptr,str)
PAR_T *ptr; /* Parameter array */
char *str;  /* Memory/Program indicator */
   {
      int sel;
      /* Find out what is to be changed. */
      show_status(ptr,str);
      do {
	 sel=menu("Change Menu",Select_Menu,6,10,42);
	 switch(sel) {
	    case 0:
	       sel_colors(ptr);
	       break;
	    case 1:
	       sel_crop(ptr);
	       break;
	    case 2:
	       sel_page(ptr,str);
	       break;
	    case 3:
	       sel_port(ptr);
	       break;
	    case 4:
	       sel_prtsc();
	       break;
	    default:
	       sel = -1;
	 }
	 if (sel > 0)
	 show_status(ptr,str);
      } while (sel >= 0);
   }
